Index: /Library/Application Support/TextMate/Bundles/OCaml.tmbundle/Syntaxes/OCaml.plist
===================================================================
--- /Library/Application Support/TextMate/Bundles/OCaml.tmbundle/Syntaxes/OCaml.plist	(revision 4165)
+++ /Library/Application Support/TextMate/Bundles/OCaml.tmbundle/Syntaxes/OCaml.plist	(working copy)
@@ -23,7 +23,7 @@
 				<key>1</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 				<key>2</key>
 				<dict>
@@ -33,12 +33,12 @@
 				<key>3</key>
 				<dict>
 					<key>name</key>
-					<string>variable.function.ocaml</string>
+					<string>variable.parameter.function.ocaml</string>
 				</dict>
 				<key>4</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 			</dict>
 			<key>match</key>
@@ -52,7 +52,7 @@
 				<key>1</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 				<key>2</key>
 				<dict>
@@ -71,7 +71,7 @@
 				<key>1</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 				<key>2</key>
 				<dict>
@@ -90,7 +90,7 @@
 				<key>1</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 				<key>2</key>
 				<dict>
@@ -109,7 +109,7 @@
 				<key>1</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 				<key>2</key>
 				<dict>
@@ -130,7 +130,7 @@
 				<key>2</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 				<key>3</key>
 				<dict>
@@ -150,7 +150,7 @@
 				<key>1</key>
 				<dict>
 					<key>name</key>
-					<string>keyword.language.ocaml</string>
+					<string>keyword.other.language.ocaml</string>
 				</dict>
 			</dict>
 			<key>name</key>
@@ -163,17 +163,17 @@
 						<key>1</key>
 						<dict>
 							<key>name</key>
-							<string>keyword.language.ocaml</string>
+							<string>keyword.other.language.ocaml</string>
 						</dict>
 						<key>2</key>
 						<dict>
 							<key>name</key>
-							<string>keyword.language.ocaml</string>
+							<string>keyword.other.language.ocaml</string>
 						</dict>
 						<key>3</key>
 						<dict>
 							<key>name</key>
-							<string>keyword.language.ocaml</string>
+							<string>keyword.other.language.ocaml</string>
 						</dict>
 						<key>4</key>
 						<dict>
@@ -183,7 +183,7 @@
 						<key>5</key>
 						<dict>
 							<key>name</key>
-							<string>variable.method.ocaml</string>
+							<string>variable.parameter.method.ocaml</string>
 						</dict>
 					</dict>
 					<key>match</key>
@@ -219,7 +219,7 @@
 			<key>match</key>
 			<string>\bopen\s+([A-Z][a-zA-Z0-9_]*(\.[A-Z][a-zA-Z0-9_]*)*)</string>
 			<key>name</key>
-			<string>keyword.module.open.ocaml</string>
+			<string>keyword.other.module.open.ocaml</string>
 		</dict>
 		<dict>
 			<key>captures</key>
@@ -233,37 +233,37 @@
 			<key>match</key>
 			<string>\bexception\s+([A-Z][a-zA-Z0-9_]*)\b</string>
 			<key>name</key>
-			<string>keyword.exception.ocaml</string>
+			<string>keyword.other.exception.ocaml</string>
 		</dict>
 		<dict>
 			<key>match</key>
 			<string>\b(int|char|float|string|list|array|mutable|ref|bool|unit|exn|option|int32|int64|nativeint|format4|lazy_t|type)\b</string>
 			<key>name</key>
-			<string>keyword.type.storage.ocaml</string>
+			<string>storage.type.ocaml</string>
 		</dict>
 		<dict>
 			<key>match</key>
 			<string>\W`[A-Z][a-zA-Z0-9_]*\b</string>
 			<key>name</key>
-			<string>keyword.type.variant.polymorphic.ocaml</string>
+			<string>keyword.other.type.variant.polymorphic.ocaml</string>
 		</dict>
 		<dict>
 			<key>match</key>
 			<string>\b[A-Z][a-zA-Z0-9_]*\b</string>
 			<key>name</key>
-			<string>keyword.type.variant.ocaml</string>
+			<string>keyword.other.type.variant.ocaml</string>
 		</dict>
 		<dict>
 			<key>match</key>
 			<string>^[ \t]*#[a-zA-Z]+</string>
 			<key>name</key>
-			<string>keyword.directive.ocaml</string>
+			<string>keyword.other.directive.ocaml</string>
 		</dict>
 		<dict>
 			<key>match</key>
 			<string>^[ \t]*#[0-9]*</string>
 			<key>name</key>
-			<string>keyword.directive.line-number.ocaml</string>
+			<string>keyword.other.directive.line-number.ocaml</string>
 		</dict>
 		<dict>
 			<key>match</key>
@@ -334,7 +334,7 @@
 			<key>match</key>
 			<string>\b(and|as|assert|begin|class|constraint|do|done|downto|else|end|exception|external|false|for|fun|function|functor|if|in|include|inherit|initializer|land|lazy|let|lor|lsl|lsr|lxor|match|mod|module|mutable|new|object|of|open|or|private|rec|sig|struct|then|to|true|try|type|val|virtual|when|while|with)\b</string>
 			<key>name</key>
-			<string>keyword.language.ocaml</string>
+			<string>keyword.other.language.ocaml</string>
 		</dict>
 	</array>
 	<key>repository</key>