Index: Commands/Wrap Selection as Link.tmCommand
===================================================================
--- Commands/Wrap Selection as Link.tmCommand	(revision 11112)
+++ Commands/Wrap Selection as Link.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -54,7 +54,7 @@
 	<key>output</key>
 	<string>insertAsSnippet</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>A42DC78E-6588-476F-8A00-40B8CCC6D2E0</string>
 </dict>
Index: Commands/Yahoo News Search.tmCommand
===================================================================
--- Commands/Yahoo News Search.tmCommand	(revision 11112)
+++ Commands/Yahoo News Search.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -42,7 +42,7 @@
 	<key>output</key>
 	<string>insertAsSnippet</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>41D61EE6-B8A9-4C21-9ECE-E336588423DB</string>
 </dict>
Index: Commands/Yahoo Web Search.tmCommand
===================================================================
--- Commands/Yahoo Web Search.tmCommand	(revision 11112)
+++ Commands/Yahoo Web Search.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -42,7 +42,7 @@
 	<key>output</key>
 	<string>insertAsSnippet</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>2E03E8C8-DC99-4D15-AE46-0E8DCE6BBE6F</string>
 </dict>
Index: Commands/Basic Wikipedia.tmCommand
===================================================================
--- Commands/Basic Wikipedia.tmCommand	(revision 11112)
+++ Commands/Basic Wikipedia.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -40,7 +40,7 @@
 	<key>output</key>
 	<string>insertAsSnippet</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>71C47F5F-41FA-40E8-A13A-238BC30984D1</string>
 </dict>
Index: Commands/Yahoo Related Suggestion.tmCommand
===================================================================
--- Commands/Yahoo Related Suggestion.tmCommand	(revision 11112)
+++ Commands/Yahoo Related Suggestion.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -37,7 +37,7 @@
 	<key>output</key>
 	<string>replaceSelectedText</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>6511380B-D4C7-408B-85FF-9E98C6AAEB4A</string>
 </dict>
Index: Commands/Lookup Word : Selection on Wikipedia and link.tmCommand
===================================================================
--- Commands/Lookup Word : Selection on Wikipedia and link.tmCommand	(revision 11112)
+++ Commands/Lookup Word : Selection on Wikipedia and link.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -101,7 +101,7 @@
 	<key>output</key>
 	<string>insertAsSnippet</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>B94A2DF9-FC40-4281-80FB-35FB2917CDE7</string>
 </dict>
Index: Commands/Yahoo Video Search.tmCommand
===================================================================
--- Commands/Yahoo Video Search.tmCommand	(revision 11112)
+++ Commands/Yahoo Video Search.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -42,7 +42,7 @@
 	<key>output</key>
 	<string>insertAsSnippet</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>50A08D59-18D6-48C1-938D-6644906F5C83</string>
 </dict>
Index: Commands/Lookup Word : Selection on Google and Link.tmCommand
===================================================================
--- Commands/Lookup Word : Selection on Google and Link.tmCommand	(revision 11112)
+++ Commands/Lookup Word : Selection on Google and Link.tmCommand	(working copy)
@@ -1,5 +1,5 @@
 <?xml version="1.0" encoding="UTF-8"?>
-<!DOCTYPE plist PUBLIC "-//Apple Computer//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
 <plist version="1.0">
 <dict>
 	<key>beforeRunningCommand</key>
@@ -42,7 +42,7 @@
 	<key>output</key>
 	<string>insertAsSnippet</string>
 	<key>scope</key>
-	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext</string>
+	<string>text.html, text.html.markdown, text.html.textile, text.bbcode, text.moinmoin, text.restructuredtext, text.tex.latex</string>
 	<key>uuid</key>
 	<string>D2F3BE59-1349-4762-9B17-A6F79A7F81B9</string>
 </dict>
Index: Preferences/LaTeX.tmPreferences
===================================================================
--- Preferences/LaTeX.tmPreferences	(revision 0)
+++ Preferences/LaTeX.tmPreferences	(revision 0)
@@ -0,0 +1,24 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE plist PUBLIC "-//Apple//DTD PLIST 1.0//EN" "http://www.apple.com/DTDs/PropertyList-1.0.dtd">
+<plist version="1.0">
+<dict>
+	<key>name</key>
+	<string>LaTeX</string>
+	<key>scope</key>
+	<string>text.tex.latex</string>
+	<key>settings</key>
+	<dict>
+		<key>shellVariables</key>
+		<array>
+			<dict>
+				<key>name</key>
+				<string>TM_LINK_FORMAT</string>
+				<key>value</key>
+				<string>\href{&lt;%= e_sn url %&gt;}{&lt;%= e_sn input %&gt;}</string>
+			</dict>
+		</array>
+	</dict>
+	<key>uuid</key>
+	<string>22EC4A8D-69B4-44D5-A029-EE67B144B53E</string>
+</dict>
+</plist>